package com.ruoyi.ss.feeRule.service;

import java.util.List;

import cn.hutool.core.lang.Opt;
import com.ruoyi.ss.feeRule.domain.FeeRule;
import com.ruoyi.ss.feeRule.domain.FeeRuleVO;
import com.ruoyi.ss.feeRule.domain.FeeRuleQuery;

/**
 * 收费模板Service接口
 *
 * @author qzz
 * @date 2024-11-20
 */
public interface IFeeRuleService
{
    /**
     * 查询收费模板
     *
     * @param ruleId 收费模板主键
     * @return 收费模板
     */
    public FeeRuleVO selectEFeeRuleByRuleId(Long ruleId);

    /**
     * 查询收费模板列表
     *
     * @param eFeeRule 收费模板
     * @return 收费模板集合
     */
    public List<FeeRuleVO> selectEFeeRuleList(FeeRuleQuery eFeeRule);

    /**
     * 新增收费模板
     *
     * @param eFeeRule 收费模板
     * @return 结果
     */
    public int insertEFeeRule(FeeRule eFeeRule);

    /**
     * 修改收费模板
     *
     * @param eFeeRule 收费模板
     * @return 结果
     */
    public int updateEFeeRule(FeeRule eFeeRule);

    /**
     * 批量删除收费模板
     *
     * @param ruleIds 需要删除的收费模板主键集合
     * @return 结果
     */
    public int deleteEFeeRuleByRuleIds(Long[] ruleIds);

    /**
     * 删除收费模板信息
     *
     * @param ruleId 收费模板主键
     * @return 结果
     */
    public int deleteEFeeRuleByRuleId(Long ruleId);

    /**
     * 根据房间id获取套餐
     */
    List<FeeRuleVO> selectEFeeRuleListByRuleIds(List<Long> ruleIds);

    /**
     * 获取每小时套餐对象
     */
    public FeeRule selectEveryHoursFeeRuleByRoomId(Long roomId);

    /**
     * 获取自定义套餐对象
     */
    List<FeeRuleVO> selectCustomFeeRuleByRoomId(Long roomId);

    /**
     * 校验是否存在基础收费模板
     */
    FeeRuleVO isExistBasicsRule(List<Long> ids);
}
